#ifndef _HEADERSET_H_
#define _HEADERSET_H_

#include "bmsfel.h"
#include "ttl.h"

class HeaderEdit : public TtEdit {
protected:
  virtual DWORD  get_ex_style();
  virtual DWORD  get_style();
};


class HeaderSet {
public:
  // static
  static int WIDTH;
  static int PADDING_TOP;

  static int EDIT_HEIGHT;
  static int LABEL_HEIGHT;

  static int ONE_PADDING_RIGHT;
  static int ONE_PADDING_LEFT;
  static int ONE_PADDING_BOTTOM;

  static void set_hash( BmsHeaderHash *hash );
  static void set_font( HFONT h_font );
  static void resize_all();
  static void repaint_edit_all();
  static HeaderSet *find_id( int id );
  static HeaderSet *find_h_wnd( HWND target );
  
private:
  static int count;
  static HeaderSet *ary[256];
  static BmsHeaderHash *bms_hash;
  static HFONT h_font;
  
  // instance
protected:
  int        index;
  TtWindow   *parent;
  char       *key;
  TtStatic   *label;
  int        label_id;
  HeaderEdit *edit;
  int        edit_id;

public:
  HeaderSet( TtWindow *parent, const char *key, int label_id, int edit_id );
  ~HeaderSet();

  void resize();
  int repaint_edit();
  bool update_hash();

  void exchange_upper();
};

#endif // _HEADERSET_H_
