#ifndef _MAINFRAME_H_
#define _MAINFRAME_H_

#include "bmsfel.h"
#include "ttl.h"

class MainFrame : public TtApp {
public:
  // static
  static const int DEFAULT_WIDTH  = 400;
  static const int DEFAULT_HEIGHT = 500;
  static const int DEFAULT_POS_X  = 0;
  static const int DEFAULT_POS_Y  = 0;
  static char *class_name;
  static bool init( HINSTANCE h_instance );

  // instance
protected:
  TtStatic  *headers_back;
  TtGroup   *headers_group;
  HeaderSet *header_sets[32];
  TtTab     *list_tab;
  ListSet   *list_sets[8];

  virtual DWORD  get_ex_style();
  virtual DWORD  get_style();
  virtual PCTSTR get_class_name();
  virtual bool created();

  LRESULT wm_command_recved( int id, int code, HWND child );
  LRESULT wm_notify_recved( int id, NMHDR *nmhdr );
  LRESULT wm_size_recved( int flag, int width, int height );
  LRESULT wm_destroy_recved();
  LRESULT wm_dropfiles_recved( HDROP h_drop );

public:
  LRESULT wnd_proc( UINT msg, WPARAM w_param, LPARAM l_param );

  void repaint_all();

  void open_bms( char *path );
  void save_bms( char *path );
};

#endif // _MAINFRAME_H_
